
#ifndef CONSTANTS_H
#define CONSTANTS_H

#include <pines.h>


//calibración estados
#define abrirTodo 0
#define delayTime 1
#define cerrarTodo 2


// variables usadas en la funcion para actualización del PWM
int programState = 0;       //estado actual dentro de la MEF
int prevProgramState = -1;  //estado anterior
int bandOk=0;               //bandera cuando ya esta calibrado
int bandDelay=0;            //bandera cuando ya se ha hecho la corección de los delays
float promedioAng=0;        //promedio de los angulos
int tol=5;                  //tolerancia entre la diferencia de los promedios y el ángulo
int stepPot=5;              //cantidad de aumento o disminucion del PWM
long t_est=0;               //tiempo para función de calibración
long t_estDelay;            //tiempo para función de corrección de delays
bool S_A=true;              //bandera cuando se esta abriendo
bool S_C=false;             // bandera cuando se esta cerrando
bool S_Q=false;             //banderta pcuando el dedo esta quieto
long lastCalibration=0;     //tiempo desde la ultima vez en la que se actualizo el PWM
int callTime= 100;          //tiempo minimo para volver a actualizarlo

long timeOpen=0;            //tiempo que se demora en abrir
long timeClose=0;           //tiempo que se demora en cerrar
int PWM=250;                //valor de PWM para calibración y correccion de delays

//valores que se mandan correspondientes a la prueba de fatiga
int pFatiga=0;
long initTime=0;            //tiempo 
int angulo_a=0;             //ángulo cuando termina de abrir 
int pot_a=0;                //valor milivoltios del potenciometro cuando termina de abrir
int angulo_c=0;             //ángulo cuando termina de cerrar
int pot_c=0;                //valor milivoltios del potenciometro cuando termina de cerrar
long timeO=0;               //tiempo en abrir
long timeC=0;               //tiempo en cerrar


typedef struct Dedo{        
    int potPin;             //pin al que esta conectado el potenciometro
    int potValor;           //milivoltios del potenciometro
    int m1;                 //motor 1
    int m2;                 // motor 2
    int band;               //bandera de calibración
    int pwm;                
    int calibracion;        // estado actual dentro de la MEF de calibración
    int prevCalibracion;    //estado anterior dentro de la MEF de calibración
    float potMax;           //milivoltios máximos del potenciometro
    float potMin;           //milivoltios minimos del potenciometro
    int potAnterior;        //valor milivoltios anteriores duarante el movimiento
    String potMaxPreferences;//key para guardar en preferences
    String potMinPreferences;
    long timerDedo;         
    float angulo;           //angulo calculado
    int estadoDedo;         //movimiento del dedo 1:abierto, 2:cerrado, 3:quieto
    int prevEstado;         //movimiento en el que se encontraba
    int bandDelay;          //bandera para cuando cada dedo ya tiene corregido el delay
    int delayOpen;          // delay corregido para apertura
    int delayClose;         //delay corregido para cierre
    long timerDelay1;       //tiempos para cada dedo mientras abre
    long timerDelay2;       //tiempos para cada dedo mientras cierra
    String delayOpenPreferences;//key para guardar en preferences
    String delayClosePreferences;
    int calibracionDelay;   //estado actual de la MEF en la corrección de los delay  
    int prevCalibracionDelay;//estado anterior de la MEF en la corrección de los delay  
  
} Dedo;
// inicialización de todas las variables para los cuatro dedos
struct Dedo indice= {potIndice,0,indice1,indice2,0,170,0,-1,0,0,0,"potMaxIndice","potMinIndice",0,0,0,-1,0,0,0,0,0,"delayOpenInd","delayCloseInd",0,-1};
struct Dedo medio= {potMedio,0,medio1,medio2,0,170,0,-1,0,0,0,"potMaxMedio","potMinMedio",0,0,0,-1,0,0,0,0,0,"delayOpenMed","delayCloseMed",0,-1};
struct Dedo anular= {potAnular,0,anular1,anular2,0,170,0,-1,0,0,0,"potMaxAnular","potMinAnular",0,0,0,-1,0,0,0,0,0,"delayOpenAnu","delayCloseAnu",0,-1};
struct Dedo menique= {potMenique,0,menique1,menique2,0,170,0,-1,0,0,0,"potMaxMenique","potMinMenique",0,0,0,-1,0,0,0,0,0,"delayOpenMeniq","delayCloseMeniq",0,-1};

#endif  // CONSTANTS_H

